#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

/*--------------------------------------------------------------------*/

void extract_zip (char *archive, char *file);
void extract_tar (char *archive, char *file);

/*--------------------------------------------------------------------*/

int cgiMain (void)
{
    char  archive[4096], file[4096];

    // extract parameters
    cgiFormStringNoNewlines ("archive", archive, sizeof (archive));
    if (archive[0] == '\0')
        error ("Archive to extract from isn't specified");
    
    cgiFormStringNoNewlines ("file", file, sizeof (file));
    if (file[0] == '\0')
        error ("File to extract isn't specified");

    /* mime_associate ?? */
    cgiHeaderContentType ("text/plain");

    // analyze filename and invoke corresponding processor
    if (mask_matchi ("*.zip", archive) || mask_matchi ("*.exe", archive))
        extract_zip (archive, file);

    else if (mask_matchi ("*.tar.gz", archive) ||
             mask_matchi ("*.tar.z",  archive) ||
             mask_matchi ("*.tgz",    archive) ||
             mask_matchi ("*.taz",    archive) ||
             mask_matchi ("*.tar",    archive))
        extract_tar (archive, file);
        
    else
        fprintf (cgiOut, "Sorry, this archive format isn't supported yet\n");

    return 0;
}

/*--------------------------------------------------------------------*/

void extract_zip (char *archive, char *file)
{
    char  buf[4096];

    sprintf (buf, "unzip %s %s -d "TEMPDIR" >"NULL_DEV,
             make_absolute (archive), file);
    cgiSaferSystem (buf);
    sprintf (buf, TEMPDIR"%s", file);
    print_file (buf);
    remove (buf);
}

/*--------------------------------------------------------------------*/

void extract_tar (char *archive, char *file)
{
    char buf[4096];
    
    sprintf (buf, "tar x%sOf %s %s",
             mask_matchi ("*.tar", archive) ? "" : "z",
             make_absolute (archive), file);
    fflush (stdout);
    cgiSaferSystem (buf);
}

