#ifndef __FILEBASE2_H_INCLUDED
#define __FILEBASE2_H_INCLUDED

#include <time.h>

#define TYPE_UNKNOWN      0  // must be the lowest
#define TYPE_SYMLINK      2
#define TYPE_REGULAR      4
#define TYPE_DIRECTORY    8  // must be the highest

struct file
{
    char        type;   // 0 - unknown, 1 - file, 2 - directory
    char        hs;     // "has subdirs" flag (directories only)
    time_t      age;    // st_ctime (useful for sorting)
    //struct tm   age1;   // broken down time
    long        size;   // in bytes
    char        *dir;   // directory where thing is
    char        *name;  // file/directory name
    char        *desc;  // description (if available)
};

struct __fb
{
    time_t             timestamp; // when it was updated
    int                N;         // no. of entries
    struct file        *files;    // actual files
};

extern struct __fb fb;

int create_database (char *sd); // gathers all files/dirs and dumps the binary database
int load_database (void);   // loads database
int whereis (char *path);
int get_directory (char *dirname, struct file *f, int *N);
int fill_list (struct file *f, int *N);
int resolve_link (struct file f);

#endif
