#ifndef __ONSITE_H_INCLUDED
#define __ONSITE_H_INCLUDED

#include "../local.h"

/*         options         */

#define DEFAULT_SEARCH SEARCH_PLAIN
#define DEFAULT_SORT   'n'
#define DEFAULT_DEPTH  2

/*         limits        */

#define MAX_ENTRIES     1000
#define MAX_DEPTH       5
#define HTTP_LIMIT      128*1024

/*         misc           */

#define SIGN_EXPAND   "<b>[+]</b>"
#define SIGN_VIEW     "<i>view</i>"
#define SIGN_CONTENTS "<i>contents</i>"

/* there are no customizable parameters below */

/*         files          */

#define HTML_PATH    ARCHIVE_PATH "html/"
#define TEMPDIR      ARCHIVE_PATH "scratch/"
#define HEADER       HTML_PATH "header.html"
#define FOOTER       HTML_PATH "footer.html"
#define COPYRIGHT    HTML_PATH "copyright.html"
#define FILELIST     TEMPDIR "files.bin"
#define NAMELIST     TEMPDIR "names.bin"
#define DESCLIST     TEMPDIR "descriptions.bin"
#define LOCKFILE     TEMPDIR "lock"
#define NULL_DEV     "/dev/null"

/*         executable names      */

#define CGI_URL        ARCHIVE_URL "bin/"
#define CGI_EXT        "cgi"
#define AUTOINDEX      CGI_URL "autoindex." CGI_EXT
#define AUTOLIST       CGI_URL "autolist." CGI_EXT
#define AUTOSEARCH     CGI_URL "autosearch." CGI_EXT
#define AUTOTREE       CGI_URL "autotree." CGI_EXT
#define AUTOEXTRACT    CGI_URL "autoextract." CGI_EXT
#define AUTONEWFILES   CGI_URL "autonewfiles." CGI_EXT
#define AUTODOWNLOAD1  CGI_URL "autodownload1." CGI_EXT
#define MAKEFILELIST   CGI_URL "automklist." CGI_EXT

#endif
