#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <unistd.h>
#include <ctype.h>

#include "cgic.h"
#include "tools1.h"
#include "tools2.h"
#include "onsite.h"

#ifdef __EMX__
#define strcasecmp stricmp
#endif

/*--------------------------------------------------------------------*/

int has_subdirs (char *dir)
{
    char          buf1[2048], *p = make_absolute (dir);
    DIR           *dd;
    struct stat   ctm;
    struct dirent *e;

    dd = opendir (p);
    if (dd == NULL) return 0;
    while ( (e = readdir (dd)) != NULL)
    {
        if (strcmp (e->d_name, ".") && strcmp (e->d_name, ".."))
        {
            strcpy (buf1, p);
            strcats (buf1, e->d_name);
            stat (buf1, &ctm);
            if (S_ISDIR(ctm.st_mode))
            {
                closedir (dd);
                return 1;
            }
        }
    }
    closedir (dd);
    return 0;
}

/*--------------------------------------------------------------------*/

char *make_absolute (char *filename)
{
    static char p[8192];
    /*char  *p = malloc (strlen (filename)+strlen (FTP_ROOT)+3);*/
    strcpy (p, FTP_ROOT);
    strcat (p, filename);
    return p;
}

/*--------------------------------------------------------------------*/

char *dir_description (char *dirname)
{
    static char buf[4096];
    char   *filename, *p;
    FILE   *fp;

    // form filename
    strcpy (buf, dirname);
    strcats (buf, ".description");
    filename = make_absolute (buf);

    if (access (filename, 00) != 0) return NULL;
    fp = fopen (filename, "rt");
    if (fp == NULL) return NULL;
    p = fgets (buf, sizeof (buf), fp);
    fclose (fp);
    if (p == NULL) return NULL;
    strip_nl (buf);
    if (buf[0] == '\0') return NULL;
    return buf;
}

/* ----------------------------------------------------------- */

char *next_readme (DIR *d)
{
    struct dirent *e;
    static char buf[1024];

    while ((e = readdir (d)) != NULL)
    {
        if (is_viewable (e->d_name) && (
            mask_matchi ("readme.*", e->d_name) ||
            !strcasecmp ("readme", e->d_name) ||
            !strcasecmp ("read.me", e->d_name) ||
            !strcmp ("file_id.diz", e->d_name) ||
            !strcmp ("welcome.msg", e->d_name) ||
            !strcmp (".message", e->d_name))
           )
        {
            strcpy (buf, e->d_name);
            return buf;
        }

    }
    return NULL;
}

/* ------------------------------------------------------------- */

void print_long_file (char *file, int lines)
{
    FILE  *fp;
    char  buf1[8192];
    int   i;
    
    // read file line by line and print it
    fp = fopen (make_absolute (file), "rt");
    if (fp == NULL) return;

    if (lines < 0) lines = 32768;
    for (i=0; i<lines; i++)
    {
        if (fgets (buf1, sizeof(buf1), fp) == NULL) break;
        fputs (buf1, stdout);
    }
    if (i == lines)
        fprintf (cgiOut, "<a href=\""WEB_ROOT"%s\">(More...)</a>\n", file);
    fclose (fp);
}

